using System;
using System.Drawing;
using System.Drawing.Imaging;

namespace TestProject
{
    /// <summary>
    /// Ʈ 
    /// </summary>
    public unsafe class BitmapHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Struct
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ȼ  - PixelData

        /// <summary>
        /// ȼ 
        /// </summary>
        private struct PixelData
        {
            //////////////////////////////////////////////////////////////////////////////////////////////////// Field
            ////////////////////////////////////////////////////////////////////////////////////////// Public

            #region Field

            /// <summary>
            /// Ķ
            /// </summary>
            public byte Blue;

            /// <summary>
            /// 
            /// </summary>
            public byte Green;

            /// <summary>
            /// 
            /// </summary>
            public byte Red;

            /// <summary>
            /// 
            /// </summary>
            public byte Alpha;

            #endregion

            //////////////////////////////////////////////////////////////////////////////////////////////////// Method
            ////////////////////////////////////////////////////////////////////////////////////////// Public

            #region ڿ ϱ - ToString()

            /// <summary>
            /// ڿ ϱ
            /// </summary>
            /// <returns>ڿ</returns>
            public override string ToString()
            {
                return "(" + Alpha.ToString() + ", " + Red.ToString() + ", " + Green.ToString() + ", " + Blue.ToString() + ")";
            }

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ʈ
        /// </summary>
        private Bitmap bitmap = null;

        /// <summary>
        /// Ʈ ʺ
        /// </summary>
        private int bitmapWidth = 0;

        /// <summary>
        /// Ʈ 
        /// </summary>
        private BitmapData bitmapData = null;

        /// <summary>
        /// ̽ 
        /// </summary>
        private Byte* basePointer = null;

        /// <summary>
        /// ȼ 
        /// </summary>
        private PixelData* pixelData = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - BitmapHelper(bitmap)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="bitmap">Ʈ</param>
        public BitmapHelper(Bitmap bitmap)
        {
            this.bitmap = bitmap;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ʈ ױ - LockBitmap()

        /// <summary>
        /// Ʈ ױ
        /// </summary>
        public void LockBitmap()
        {
            Rectangle rectangle = new Rectangle(Point.Empty, this.bitmap.Size);

            this.bitmapWidth = (int)(rectangle.Width * sizeof(PixelData));

            if(this.bitmapWidth % 4 != 0)
            {
                this.bitmapWidth = 4 * (this.bitmapWidth / 4 + 1);
            }

            this.bitmapData = this.bitmap.LockBits(rectangle, ImageLockMode.ReadWrite, PixelFormat.Format32bppArgb);

            this.basePointer = (Byte*)this.bitmapData.Scan0.ToPointer();
        }

        #endregion

        #region ȼ ϱ - GetPixel(int x, int y)

        /// <summary>
        /// ȼ ϱ
        /// </summary>
        /// <param name="x">X ǥ</param>
        /// <param name="y">Y ǥ</param>
        /// <returns></returns>
        public Color GetPixel(int x, int y)
        {
            this.pixelData = (PixelData*)(this.basePointer + y * this.bitmapWidth + x * sizeof(PixelData));

            return Color.FromArgb(this.pixelData->Alpha, this.pixelData->Red, this.pixelData->Green, this.pixelData->Blue);
        }

        #endregion
        #region  ȼ ϱ - GetPixelNext()

        /// <summary>
        ///  ȼ ϱ
        /// </summary>
        /// <returns></returns>
        public Color GetPixelNext()
        {
            this.pixelData++;

            return Color.FromArgb(this.pixelData->Alpha, this.pixelData->Red, this.pixelData->Green, this.pixelData->Blue);
        }

        #endregion
        #region ȼ ϱ - SetPixel(x, y, color)

        /// <summary>
        /// ȼ ϱ
        /// </summary>
        /// <param name="x">X ǥ</param>
        /// <param name="y">Y ǥ</param>
        /// <param name="color"></param>
        public void SetPixel(int x, int y, Color color)
        {
            PixelData* pixelData = (PixelData*)(this.basePointer + y * this.bitmapWidth + x * sizeof(PixelData));

            pixelData->Alpha = color.A;
            pixelData->Red   = color.R;
            pixelData->Green = color.G;
            pixelData->Blue  = color.B;
        }

        #endregion

        #region Ʈ  ϱ - UnlockBitmap()

        /// <summary>
        /// Ʈ  ϱ
        /// </summary>
        public void UnlockBitmap()
        {
            this.bitmap.UnlockBits(this.bitmapData);

            this.bitmapData  = null;
            this.basePointer = null;
        }

        #endregion
    }
}