using System;
using System.Drawing;
using System.Drawing.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    ///  ÷ Ʈ
    /// </summary>
    public sealed class TransparentSplashControl : Control
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Import
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region ũ  ϱ - GetDesktopWindow()

        /// <summary>
        /// ũ  ϱ
        /// </summary>
        /// <returns>ũ  ڵ</returns>
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern IntPtr GetDesktopWindow();

        #endregion
        #region θ ϱ - SetParent(childHandle, parentHandle)

        /// <summary>
        /// θ ϱ
        /// </summary>
        /// <param name="childHandle">ڽ ڵ</param>
        /// <param name="parentHandle">θ ڵ</param>
        /// <returns>ó </returns>
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        private static extern IntPtr SetParent(IntPtr childHandle, IntPtr parentHandle);

        #endregion
        #region  ġ ϱ - SetWindowPos(windowHandle, windowHandleInsertAfter, x, y, width, height, flag)

        /// <summary>
        ///  ġ ϱ
        /// </summary>
        /// <param name="windowHandle"> ڵ</param>
        /// <param name="windowHandleInsertAfter">߰  տ   ڵ</param>
        /// <param name="x">X ǥ</param>
        /// <param name="y">Y ǥ</param>
        /// <param name="width">ʺ</param>
        /// <param name="height"></param>
        /// <param name="flag">÷</param>
        /// <returns>ó </returns>
        [DllImport("user32.dll", EntryPoint = "SetWindowPos", CallingConvention = CallingConvention.StdCall, SetLastError = true)]
        private static extern int SetWindowPos(IntPtr windowHandle, IntPtr windowHandleInsertAfter, int x, int y, int width, int height, uint flag);

        #endregion
        #region Ʈ ϱ - BitBlt(targetDCHandle, targetX, targetY, width, height, sourceDCHandle, sourceX, sourceY, ropFlag)

        /// <summary>
        /// Ʈ ϱ
        /// </summary>
        /// <param name="targetDCHandle">Ÿ ̽ ؽƮ ڵ</param>
        /// <param name="targetX">Ÿ X ǥ</param>
        /// <param name="targetY">Ÿ Y ǥ</param>
        /// <param name="width">ʺ</param>
        /// <param name="height"></param>
        /// <param name="sourceDCHandle">ҽ ̽ ؽƮ ڵ</param>
        /// <param name="sourceX">ҽ X ǥ</param>
        /// <param name="sourceY">ҽ Y ǥ</param>
        /// <param name="ropFlag">  ÷</param>
        /// <returns>ó </returns>
        [DllImport("gdi32.dll")]
        private static extern bool BitBlt(IntPtr targetDCHandle, int targetX, int targetY, int width, int height, IntPtr sourceDCHandle, int sourceX, int sourceY, uint ropFlag);

        #endregion
        #region ȼ ϱ - SetPixel(dcHandle, x, y, color)

        /// <summary>
        /// ȼ ϱ
        /// </summary>
        /// <param name="dcHandle">̽ ؽƮ ڵ</param>
        /// <param name="x">X ǥ</param>
        /// <param name="y">Y ǥ</param>
        /// <param name="color"></param>
        /// <returns>  </returns>
        [DllImport("gdi32.dll")]
        private static extern uint SetPixel(IntPtr dcHandle, int x, int y, uint color);

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// νϽ
        /// </summary>
        private static TransparentSplashControl _instance;

        /// <summary>
        ///  ü
        /// </summary>
        private static object _lockObject = new object();

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// WS_EX_TOPMOST
        /// </summary>
        private const int WS_EX_TOPMOST = unchecked((int)0x00000008L);

        /// <summary>
        /// WS_EX_TOOLWINDOW
        /// </summary>
        private const int WS_EX_TOOLWINDOW = unchecked((int)0x00000080);

        /// <summary>
        /// SWP_NOSIZE
        /// </summary>
        private const uint SWP_NOSIZE = 0x0001;

        /// <summary>
        /// SWP_NOMOVE
        /// </summary>
        private const uint SWP_NOMOVE = 0x0002;

        /// <summary>
        /// HWND_TOPMOST
        /// </summary>
        private const int HWND_TOPMOST = -1;


        /// <summary>
        /// 
        /// </summary>
        private string title;

        /// <summary>
        /// ּ
        /// </summary>
        private string comment;

        /// <summary>
        /// ڿ 
        /// </summary>
        private StringFormat stringFormat;

        /// <summary>
        /// ؽƮ  X
        /// </summary>
        private int textOffsetX;

        /// <summary>
        /// ؽƮ  Y
        /// </summary>
        private int textOffsetY;

        /// <summary>
        /// 
        /// </summary>
        private int leading;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region νϽ - Instance

        /// <summary>
        /// νϽ
        /// </summary>
        public static TransparentSplashControl Instance
        {
            get
            {
                lock(_lockObject)
                {
                    if(_instance == null || _instance.IsDisposed)
                    {
                        _instance = new TransparentSplashControl();
                    }

                    return _instance;
                }
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region  - Title

        /// <summary>
        /// 
        /// </summary>
        public string Title
        {
            get
            {
                return this.title;
            }
            set
            {
                if(this.title != value)
                {
                    this.title = value;

                    Invalidate
                    (
                        new Rectangle
                        (
                            Convert.ToInt32(TitleRectangle.X),
                            Convert.ToInt32(TitleRectangle.Y),
                            TextAreaWidth,
                            Convert.ToInt32(TitleRectangle.Height)
                        )
                    );

                    Update();
                }
            }
        }

        #endregion
        #region ּ - Comment

        /// <summary>
        /// ּ
        /// </summary>
        public string Comment
        {
            get
            {
                return this.comment;
            }
            set
            {
                if(this.comment != value)
                {
                    this.comment = value;

                    Invalidate
                    (
                        new Rectangle
                        (
                            Convert.ToInt32(CommentRectangle.X),
                            Convert.ToInt32(CommentRectangle.Y),
                            TextAreaWidth,
                            Convert.ToInt32(CommentRectangle.Height)
                        )
                    );

                    Update();
                }
            }
        }

        #endregion
        #region ؽƮ  X - TextAreaX

        /// <summary>
        /// ؽƮ  X
        /// </summary>
        public int TextAreaX { get; set; }

        #endregion
        #region ؽƮ  Y - TextAreaY

        /// <summary>
        /// ؽƮ  Y
        /// </summary>
        public int TextAreaY { get; set; }

        #endregion
        #region ؽƮ  ʺ - TextAreaWidth

        /// <summary>
        /// ؽƮ  ʺ
        /// </summary>
        public int TextAreaWidth { get; set; }

        #endregion
        #region ؽƮ   - TextAreaHeight

        /// <summary>
        /// ؽƮ  
        /// </summary>
        public int TextAreaHeight { get; set; }

        #endregion
        #region   - TransparencyColor

        /// <summary>
        ///  
        /// </summary>
        public Color TransparencyColor { get; set; }

        #endregion
        #region  簢 - TitleRectangle

        /// <summary>
        ///  簢
        /// </summary>
        private RectangleF TitleRectangle { get; set; }

        #endregion
        #region ּ 簢 - CommentRectangle

        /// <summary>
        /// ּ 簢
        /// </summary>
        private RectangleF CommentRectangle { get; set; }

        #endregion
        #region ּ Ʈ - CommentFont

        /// <summary>
        /// ּ Ʈ
        /// </summary>
        public Font CommentFont { get; set; }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region  Ű  - CreateParams

        /// <summary>
        ///  Ű 
        /// </summary>
        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams createParams = base.CreateParams;

                createParams.ExStyle |= WS_EX_TOOLWINDOW | WS_EX_TOPMOST;

                createParams.Parent = IntPtr.Zero;

                return createParams;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  - TransparentSplashControl()

        /// <summary>
        /// 
        /// </summary>
        private TransparentSplashControl()
        {
            Title   = string.Empty;
            Comment = string.Empty;

            Font        = new Font("Verdana", 28.00f, FontStyle.Regular, GraphicsUnit.Point, ((byte)(0)));
            CommentFont = new Font("Verdana", 8.25f , FontStyle.Regular, GraphicsUnit.Point, ((byte)(0)));

            SetStyle(ControlStyles.DoubleBuffer        , false);
            SetStyle(ControlStyles.UserPaint           , true );
            SetStyle(ControlStyles.AllPaintingInWmPaint, true );

            this.stringFormat = new StringFormat();

            this.stringFormat.FormatFlags |= StringFormatFlags.NoWrap;
            this.stringFormat.FormatFlags |= StringFormatFlags.MeasureTrailingSpaces;

            this.textOffsetY = 0;
            this.textOffsetX = 10;

            this.leading = 6;

            Visible = false;

            TextAreaX      = 0;
            TextAreaY      = 0;
            TextAreaWidth  = 0;
            TextAreaHeight = 0;

            TransparencyColor = Color.Black;

            CommentRectangle = RectangleF.Empty;
            TitleRectangle   = RectangleF.Empty;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region ÷ ϱ - BeginDisplay()

        /// <summary>
        /// ÷ ϱ
        /// </summary>
        public static void BeginDisplay()
        {
            if(!Instance.Visible)
            {
                Instance.SetLocation();

                if(!Instance.Created)
                {
                    Instance.CreateControl();
                }

                SetWindowPos(Instance.Handle, (IntPtr)HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

                Instance.Visible = true;

                Instance.Refresh();
            }
        }

        #endregion
        #region ÷ ϱ - EndDisplay()

        /// <summary>
        /// ÷ ϱ
        /// </summary>
        public static void EndDisplay()
        {
            Instance.Visible = false;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region ڵ  óϱ - OnHandleCreated(e)

        /// <summary>
        /// ڵ  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnHandleCreated(EventArgs e)
        {
            IntPtr desktopWindowHandle = IntPtr.Zero;

            if(Handle != IntPtr.Zero)
            {
                desktopWindowHandle = GetDesktopWindow();

                SetParent(Handle, desktopWindowHandle);
            }

            if(TextAreaWidth == 0)
            {
                TextAreaWidth = ClientRectangle.Width;
            }

            if(TextAreaHeight == 0)
            {
                TextAreaHeight = ClientRectangle.Height;
            }

            CommentRectangle = new RectangleF(0, 0, (float)TextAreaWidth, (float)TextAreaHeight);
            TitleRectangle   = new RectangleF(0, 0, (float)TextAreaWidth, (float)TextAreaHeight);

            base.OnHandleCreated(e);
        }

        #endregion
        #region  ̹  óϱ - OnBackgroundImageChanged(e)

        /// <summary>
        ///  ̹  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnBackgroundImageChanged(EventArgs e)
        {
            base.OnBackgroundImageChanged(e);

            if(BackgroundImage != null)
            {
                Width  = BackgroundImage.Width;
                Height = BackgroundImage.Height;

                SetLocation();
            }

            Refresh();
        }

        #endregion
        #region  Ʈ óϱ - OnPaintBackground(e)

        /// <summary>
        ///  Ʈ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPaintBackground(PaintEventArgs e)
        {
        }

        #endregion
        #region Ʈ óϱ - OnPaint(e)

        /// <summary>
        /// Ʈ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPaint(PaintEventArgs e)
        {
            if(Bounds.Width > 0 && Bounds.Height > 0 && Visible)
            {
                Graphics graphics = e.Graphics;

                graphics.SetClip(e.ClipRectangle);

                graphics.TextRenderingHint = TextRenderingHint.ClearTypeGridFit;

                #region ̹   óѴ.

                Color transparentColor = Color.FromArgb(TransparencyColor.R, TransparencyColor.G, TransparencyColor.B);

                IntPtr dcHandle = graphics.GetHdc();

                Point point = new Point();

                Color pixelColor;

                Bitmap bitmap = (Bitmap)BackgroundImage;

                BitmapHelper bitmapHelper = new BitmapHelper(bitmap);

                bitmapHelper.LockBitmap();

                for(point.Y = 0; point.Y < BackgroundImage.Height; point.Y++)
                {
                    for(point.X = 0; point.X < BackgroundImage.Width; point.X++)
                    {
                        if((pixelColor = bitmapHelper.GetPixel(point.X, point.Y)) != transparentColor)
                        {
                            SetPixel(dcHandle, point.X, point.Y, GetColorValue(pixelColor));
                        }
                    }
                }

                bitmapHelper.UnlockBitmap();

                graphics.ReleaseHdc();

                #endregion
                #region ؽƮ ׸.

                this.textOffsetY = TextAreaY;

                if(Title != string.Empty)
                {
                    Font fontTitle = new Font(Font, FontStyle.Bold);

                    SizeF titleSize = graphics.MeasureString(Title, fontTitle, TextAreaWidth, this.stringFormat);

                    RectangleF titleRectangle = new RectangleF(TextAreaX + this.textOffsetX, this.textOffsetY, titleSize.Width, titleSize.Height);

                    SolidBrush titleBrush = new SolidBrush(ForeColor);

                    graphics.DrawString(Title, fontTitle, titleBrush, titleRectangle, this.stringFormat);

                    titleBrush.Dispose();

                    fontTitle.Dispose();

                    TitleRectangle = titleRectangle;

                    this.textOffsetY += this.leading + Convert.ToInt32(titleRectangle.Height);
                }

                if(Comment != string.Empty)
                {
                    SizeF commentSize = graphics.MeasureString(Comment, CommentFont, TextAreaWidth, this.stringFormat);

                    this.textOffsetY += Convert.ToInt32(Math.Ceiling(commentSize.Height));

                    RectangleF commentRectangle = new RectangleF(TextAreaX + this.textOffsetX, this.textOffsetY, commentSize.Width, commentSize.Height);

                    SolidBrush commentBrush = new SolidBrush(ForeColor);

                    graphics.DrawString(Comment, CommentFont, commentBrush, commentRectangle, this.stringFormat);

                    commentBrush.Dispose();

                    CommentRectangle = commentRectangle;
                }

                #endregion
            }
        }

        #endregion
        #region ҽ ϱ - Dispose(disposing)

        /// <summary>
        /// ҽ ϱ
        /// </summary>
        /// <param name="disposing"> </param>
        protected override void Dispose(bool disposing)
        {
            if(disposing)
            {
                CommentFont.Dispose();

                CommentFont = null;

                if(this.stringFormat != null)
                {
                    this.stringFormat.Dispose();

                    this.stringFormat = null;
                }
            }

            base.Dispose(disposing);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region  ̹ ϱ - SetBackgroundImage(image)

        /// <summary>
        ///  ̹ ϱ
        /// </summary>
        /// <param name="image">̹</param>
        public static void SetBackgroundImage(Image image)
        {
            Instance.BackgroundImage = image;
        }

        #endregion
        #region  ϱ - SetTitle(title)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="title"></param>
        public static void SetTitle(string title)
        {
            Instance.Title = title;
        }

        #endregion
        #region ּ ϱ - SetComment(comment)

        /// <summary>
        /// ּ ϱ
        /// </summary>
        /// <param name="comment">ּ</param>
        public static void SetComment(string comment)
        {
            Instance.Comment = comment;
        }

        #endregion

        #region ġ ϱ - SetLocation()

        /// <summary>
        /// ġ ϱ
        /// </summary>
        private void SetLocation()
        {
            Rectangle workingArea = SystemInformation.WorkingArea;

            int x = (workingArea.Width  - Width ) / 2;
            int y = (workingArea.Height - Height) / 2;

            Location = new Point(x, y);
        }

        #endregion
        #region   ϱ - GetColorValue(color)

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <param name="color"></param>
        /// <returns> </returns>
        private uint GetColorValue(Color color)
        {
            return Convert.ToUInt32((color.B << 16 | color.G << 8 | color.R));
        }

        #endregion
    }
}